/**
 * @see https://umijs.org/zh-CN/plugins/plugin-access
 * */
export default function access(initialState: { currentUser?: API.CurrentUser | undefined }) {
  const permission = initialState?.currentUser?.permission || []
  const authRouteFilter = route => {
    if (initialState?.currentUser?.account === 'admin') {
      return true
    }
    const permissionList = permission.map(item => item.match(/^view(\w*)/)).map(item => item[1])
    const newPermission = permissionList.map(item => item.replace(item[0], item[0].toLowerCase()))

    const name = route.name.match(/^(\w*)-/)?.[1]
    if (route.name && newPermission.includes(`${name}`)) {
      return true
    }
    return false
  }
  return {
    canAdmin: initialState?.currentUser?.account === 'admin',
    authRouteFilter
  }
}
